<?php

// モジュール名
define('MDL_DOWN_CW', 'mdl_db_export');
require_once(DATA_REALDIR. 'module/Tar.php');

// {{{ requires
require_once(CLASS_REALDIR . 'pages/admin/LC_Page_Admin.php');
require_once(DATA_REALDIR . 'class_extends/helper_extends/SC_Helper_CSV_Ex.php');

/**
 * EC-CUBE ver.2.11.0 > ver.2.12.0移行ツール
 *
 * @package Page
 * @author Cyber-Will Inc.
 */
class LC_Page_Mdl_Down_Cw_Config extends LC_Page_Admin
{
    var $baseinfo_id_count = 0;
    var $objQuery;
    var $module_name;
    var $module_title;

    /**
     * コンストラクタ
     *
     * @return void
     */
    function LC_Page_Mdl_Down_Cw_Config()
    {
        $this->module_name = MDL_DOWN_CW;
        $this->module_title = '2.12データエクスポートツール';
        //移行用CSVファイル保存パス(適当に修正してください)
        $this->module_csv_path = MODULE_REALDIR . $this->module_name . '/';
        $this->objQuery = new SC_Query();
        $this->objSess = new SC_Session();
        $this->objFormParam = new SC_FormParam();
        // 実行時間を制限しない
        set_time_limit(0);
    }

    /**
     * Page を初期化する.
     *
     * @return void
     */
    function init()
    {
        parent::init();
        $this->tpl_subtitle = "2.12移行プラグイン";
        $this->tpl_mainpage = MODULE_REALDIR . $this->module_name . '/config.tpl';
        $this->tpl_subtitle = $this->module_title;
    }

    /**
     * Page のプロセス.
     *
     * @return void
     */
    function process()
    {

        if ($_POST['mode'] == 'save') {
            // CSVを保存する
            $this->lfMakeCsv();
        }
        $this->setTemplate($this->tpl_mainpage);
        $this->sendResponse();
    }

    /**
     * デストラクタ.
     *
     * @return void
     */
    function destroy()
    {
        parent::destroy();
    }

    /**
     * エラーチェック
     */
    function checkError()
    {
        $this->objFormParam->convParam();
        return $this->objFormParam->checkError();
    }

    /*
     * lfDownloadCsv CSVを保存する
     */
    function lfMakeCsv()
    {
        $objCSV = new SC_Helper_CSV_Ex();
        $arrDatabase = $this->lfGetDatabase();
        //一応それぞれのDBに対してカラムを指定して取り出す。
        $files = '';
        foreach ($arrDatabase as $key => $val) {
        $objQuery = new SC_Query();
            switch ($key) {
                case 'dtb_products_class':
                    //処理
                    $table = 'dtb_products_class T1 LEFT JOIN dtb_products USING(product_id)';
                    $save_name = 'dtb_products_class';
                    $where = "product_id <> '0' AND product_class_id <> '0'";
                    break;
                case 'dtb_products':
                    $table = 'dtb_products LEFT JOIN dtb_products_class USING(product_id)';
                    $save_name = 'dtb_products';
                    $where = 'dtb_products_class.del_flg = 0';
                    break;
                case 'dtb_category':
                    $table = 'dtb_category';
                    $save_name = 'dtb_category';
                    $where = 'del_flg = 0';
                    $objQuery->setOrder('level, category_id');
                default:
                    $table = $key;
                    $save_name = $key;
                    $where = '';
                    break;
            }
            $arrOutputCols = $val;

            $arrval = array();

            $dataRows = $objQuery->select(
                SC_Utils_Ex::sfGetCommaList($arrOutputCols),
                $table, $where, $arrval);

            //CSV作成

            $this->lfSaveCsv($dataRows, $save_name);
            $files .= ' ' . $save_name . '.csv';
            $arrCsvFile[] = $save_name . '.csv';
        }

        //AUTH_MAGICを保存
        $out = $this->module_csv_path . 'auth.txt';
        $fp = fopen($out, 'w+');
        fwrite($fp, AUTH_MAGIC);
        fclose($fp);
        $arrCsvFile[] = 'auth.txt';

        //CSVをtar圧縮、送信
        //ファイル名を作成する
        $fname = 'shift_data' . date('YmdHis') . '.tar.gz';
        if (is_file($this->module_csv_path . $fname)) {
            unlink($this->module_csv_path . $fname);
        }

        //CSVフォルダに移動する
        chdir($this->module_csv_path);

        //gzip圧縮をおこなう
        $tar = new Archive_Tar($fname, TRUE);
        $tar->create($arrCsvFile);

        // ダウンロード用HTTPヘッダ出力
        header("Content-disposition: attachment; filename={$fname}");
        header("Content-type: application/octet-stream; name={$fname}");
        header('Cache-Control: ');
        header('Pragma: ');
        readfile($fname);
        // ファイル削除
        foreach ($arrCsvFile as $val) {
            unlink($this->module_csv_path . $val);
        }
        unlink($this->module_csv_path . $fname);
        exit;

    }

    function lfSaveCsv($arrayData, $file_name)
    {
        $file_name .= '.csv';

        $csvString = '';
        /* データを出力 */
        foreach ($arrayData as $lineArray) {
            $lineString = $this->lfArrayToCsv($lineArray);
            $lineString = mb_convert_encoding($lineString, 'SJIS-Win');
            $csvString .= $lineString . "\n";
        }

        // ファイルを書き出し
        $out = $this->module_csv_path . $file_name;
        $fp = fopen($out, 'w+');
        fwrite($fp, $csvString);
        fclose($fp);
    }

    /**
     * 1次元配列を1行のCSVとして返す
     * 2.4.2以前に無いのでここにも設置
     * 参考: http://jp.php.net/fputcsv
     */
    function lfArrayToCsv($fields, $delimiter = ',', $enclosure = '"',
        $arrayDelimiter = '|'
    ) {

        if (strlen($delimiter) != 1) {
            trigger_error('delimiter must be a single character', E_USER_WARNING);
            return '';
        }

        if (strlen($enclosure) < 1) {
            trigger_error('enclosure must be a single character', E_USER_WARNING);
            return '';
        }

        foreach (array_keys($fields) as $key) {
            $field =& $fields[$key];

            // 配列を「|」区切りの文字列に変換する
            if (is_array($field)) {
                $field = implode($arrayDelimiter, $field);
            }

            /* enclose a field that contains a delimiter, an enclosure character, or a newline */
            if (is_string($field)
                && preg_match('/[' . preg_quote($delimiter) . preg_quote($enclosure) . '\\s]/', $field)
            ) {
                $field = $enclosure
                    . preg_replace('/' . preg_quote($enclosure)
                        . '/', $enclosure . $enclosure, $field)
                    . $enclosure;
            }
        }

        return implode($delimiter, $fields);
    }

    // 取得するカラムを指定する
    function lfGetDatabase()
    {
        //基本情報
        $baseinfo_id_count++;
        $arrDatabase['dtb_baseinfo'] = array(
             "'".$baseinfo_id_count."' as id",
            'company_name',
            'company_kana',
            'zip01',
            'zip02',
            'pref',
            'addr01',
            'addr02',
            'tel01',
            'tel02',
            'tel03',
            'fax01',
            'fax02',
            'fax03',
            'business_hour',
            'law_company',
            'law_manager',
            'law_zip01',
            'law_zip02',
            'law_pref',
            'law_addr01',
            'law_addr02',
            'law_tel01',
            'law_tel02',
            'law_tel03',
            'law_fax01',
            'law_fax02',
            'law_fax03',
            'law_email',
            'law_url',
            'law_term01',
            'law_term02',
            'law_term03',
            'law_term04',
            'law_term05',
            'law_term06',
            'law_term07',
            'law_term08',
            'law_term09',
            'law_term10',
            'tax',
            'tax_rule',
            'email01',
            'email02',
            'email03',
            'email04',
            'email05',
            'free_rule',
            'shop_name',
            'shop_kana',
            'shop_name_eng',
            'point_rate',
            'welcome_point',
            'update_date',
            'top_tpl',
            'product_tpl',
            'detail_tpl',
            'mypage_tpl',
            'good_traded',
            'message',
            'regular_holiday_ids',
        );

        // regular_holiday_idsカラム(59番目)を調整
        if (version_compare(ECCUBE_VERSION, '2.11.0', '<')) {
            $arrDatabase['dtb_baseinfo'][58] = 'NULL AS regular_holiday_ids';
        }

        //顧客データ
        $arrDatabase['dtb_customer'] = array(
            'customer_id',
            'name01',
            'name02',
            'kana01',
            'kana02',
            'zip01',
            'zip02',
            'pref',
            'addr01',
            'addr02',
            'email',
            'email_mobile',
            'tel01',
            'tel02',
            'tel03',
            'fax01',
            'fax02',
            'fax03',
            'sex',
            'job',
            'birth',
            'password',
            'reminder',
            'reminder_answer',
            'first_buy_date',
            'last_buy_date',
            'buy_times',
            'buy_total',
            'point',
            'note',
            'status',
            'create_date',
            'update_date',
            'del_flg',
            'mobile_phone_id',
            'mailmaga_flg',
        );
        //顧客データ
        $arrDatabase['dtb_other_deliv'] = array(
            'other_deliv_id',
            'customer_id',
            'name01',
            'name02',
            'kana01',
            'kana02',
            'zip01',
            'zip02',
            'pref',
            'addr01',
            'addr02',
            'tel01',
            'tel02',
            'tel03',
            "'' as fax01",
            "'' as fax02",
            "'' as fax03",
        );
        //受注データ
        $arrDatabase['dtb_order'] = array(
            'order_id',
            'order_temp_id',
            'customer_id',
            'message',
            'order_name01',
            'order_name02',
            'order_kana01',
            'order_kana02',
            'order_email',
            'order_tel01',
            'order_tel02',
            'order_tel03',
            'order_fax01',
            'order_fax02',
            'order_fax03',
            'order_zip01',
            'order_zip02',
            'order_pref',
            'order_addr01',
            'order_addr02',
            'order_sex',
            'order_birth',
            'order_job',
            'subtotal',
            'discount',
            'deliv_id',
            'deliv_fee',
            'charge',
            'use_point',
            'add_point',
            'birth_point',
            'tax',
            'total',
            'payment_total',
            'payment_id',
            'payment_method',
            'note',
            'status',
            'create_date',
            'update_date',
            'commit_date',
            'payment_date',
            "'' as device_type_id",
            'del_flg',
            'memo01',
            'memo02',
            'memo03',
            'memo04',
            'memo05',
            'memo06',
            'memo07',
            'memo08',
            'memo09',
            'memo10',
        );
        $arrDatabase['dtb_order_detail'] = array(
            'order_detail_id',
            'order_id',
            'product_id',
            'product_class_id',
            'product_name',
            'product_code',
            'classcategory_name1',
            'classcategory_name2',
            'price',
            'quantity',
            'point_rate',
        );
        //商品データ
        $arrDatabase['dtb_products'] = array(
            'DISTINCT dtb_products.product_id',
            'name',
            'NULL as maker_id',
            'dtb_products.status',
            'comment1',
            'comment2',
            'comment3',
            'comment4',
            'comment5',
            'comment6',
            'note',
            'main_list_comment',
            'main_list_image',
            'main_comment',
            'main_image',
            'main_large_image',
            'sub_title1',
            'sub_comment1',
            'sub_image1',
            'sub_large_image1',
            'sub_title2',
            'sub_comment2',
            'sub_image2',
            'sub_large_image2',
            'sub_title3',
            'sub_comment3',
            'sub_image3',
            'sub_large_image3',
            'sub_title4',
            'sub_comment4',
            'sub_image4',
            'sub_large_image4',
            'sub_title5',
            'sub_comment5',
            'sub_image5',
            'sub_large_image5',
            'sub_title6',
            'sub_comment6',
            'sub_image6',
            'sub_large_image6',
            'dtb_products.del_flg',
            'dtb_products.creator_id',
            'dtb_products.create_date',
            'dtb_products.update_date',
            'deliv_date_id',
        );

        // noteカラム(19番目)を調整
        if (version_compare(ECCUBE_VERSION, '2.4.0', '<')) {
            $arrDatabase['dtb_products'][18] = "'' AS note";
        }

        $arrDatabase['dtb_products_class'] = array(
            "T1.product_class_id",
            'T1.product_id',
            '(SELECT classcategory_id FROM dtb_class_combination '
                . 'WHERE dtb_class_combination.class_combination_id = '
                . 'T1.class_combination_id) '
                . 'as classctegory_id1',
            '(SELECT classcategory_id as classcategory_id2 '
                . 'FROM dtb_class_combination as T2_1 '
                . 'WHERE T2_1.class_combination_id in '
                . '(SELECT parent_class_combination_id '
                . 'FROM dtb_class_combination,dtb_products_class '
                . 'WHERE dtb_class_combination.class_combination_id = '
                . 'T1.class_combination_id '
                . ')) as classcategory_id2 ',
                  'T1.product_type_id ',
                  'product_code ',
                  'stock ',
                  'stock_unlimited ',
                  'T1.sale_limit ',
                  'price01 ',
                  'price02 ',
                  'deliv_fee ',
                  'point_rate ',
                  'T1.creator_id ',
                  'T1.create_date ',
                  'T1.update_date ',
                  'T1.down_filename ',
                  'T1.down_realfilename ',
                  'dtb_products.del_flg ',
        );
        //商品カテゴリデータ
        $arrDatabase['dtb_category'] = array(
            'category_id',
            'category_name',
            'parent_category_id',
            'level',
            'rank',
            'creator_id',
            'create_date',
            'update_date',
            'del_flg',
        );
        $arrDatabase['dtb_product_categories'] = array(
            'product_id',
            'category_id',
            'rank',
        );
        $arrDatabase['dtb_class'] = array(
            'class_id',
            'name',
            'rank',
            'creator_id',
            'create_date',
            'update_date',
            'del_flg',
        );
        $arrDatabase['dtb_classcategory'] = array(
            'classcategory_id',
            'name',
            'class_id',
            'rank',
            'creator_id',
            'create_date',
            'update_date',
            'del_flg',
        );
        $arrDatabase['dtb_shipping'] = array(
            'shipping_id',
            'order_id',
            'shipping_name01',
            'shipping_name02',
            'shipping_kana01',
            'shipping_kana02',
            'shipping_tel01',
            'shipping_tel02',
            'shipping_tel03',
            'shipping_fax01',
            'shipping_fax02',
            'shipping_fax03',
            'shipping_pref',
            'shipping_zip01',
            'shipping_zip02',
            'shipping_addr01',
            'shipping_addr02',
            'deliv_id',
            'time_id',
            'shipping_time',
            'shipping_num',
            'shipping_date',
            'shipping_commit_date',
            'rank',
            'create_date',
            'update_date',
            'del_flg',
        );

        
        return $arrDatabase;
    }
}

